/*
 *   #   # ####     #    #######
 *   ##  # #       # #      #    Network Exploit Automation Tool
 *   # # # ####   #####     #
 *   #  ## #     #     #    #   (c) 2000 Mixter <mixter@newyorkoffice.com>,
 *   #   # #### #       #   #     (c) 2XS Ltd. -- http://2xss.com
 *
 *      cmdsocket - lower-level script language commands functionality
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#ifndef CMDSOCKET_H
#define CMDSOCKET_H
#define _GNU_SOURCE
#ifdef __STRICT_ANSI__
#undef __STRICT_ANSI__		// lalala.. rpc includes SUCK!
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#define __STRICT_ANSI__
#include <sys/socket.h>
#ifndef _NEAT_L
#undef __STRICT_ANSI__
#include <rpc/rpc.h>
#define __STRICT_ANSI__
#endif
#else
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifndef _NEAT_L
#include <rpc/rpc.h>
#endif
#endif
#include "language.h"
#include "smod.h"
#pragma interface "cmdsocket"

struct osnum
{
  char *pat;
  int ver;
};

extern struct osnum osidx[];

class cmdsocket
{
 protected:
#ifndef _NEAT_L
  CLIENT *cl;
#else
  void *cl;		// ahhh... sighhh...
#endif
  int cs;
  unsigned long rproc;
  char *ftppath;
  char *ftpip;
  int current_os;
  // assign new stream socket to cs
  int tcpsocket(void);
  // assign new datagram socket to cs
  int udpsocket(void);
  // assign tcp procedure call to client
  int rpcclient_tcp(unsigned long, unsigned long, struct sockaddr_in *);
  // assign udp procedure call to client
  int rpcclient_udp(unsigned long, unsigned long, struct sockaddr_in *);
  // auto-bouncing connect() front-end
  int bconnect(unsigned int, unsigned short);
  // sub functions to receive and evaluate ftp input, return # of writables
  // create dynamic ftppath string, if writable dir is found
  int writable_get (void);
 public:
  cmdsocket(void);
  ~cmdsocket(void);
};

#endif
